#ifndef MRK_AST
#define MRK_AST

#include <stdlib.h>

#include "mrk/common.h"

#define MRK_AST_NODE_ARGS 1

typedef enum mrk_ast_node_type {
  mrk_ast_node_type_none = 0,
  mrk_ast_node_type_header,
  mrk_ast_node_type_sentence,
} mrk_ast_node_type;

typedef struct mrk_ast_node {
  struct {
    struct mrk_ast_node **arr;
    size_t len;
  } children;
  mrk_ast_node_type type;
  struct {
    void *ptr;
    size_t num;
  } args[MRK_AST_NODE_ARGS];
} mrk_ast_node;

/**
 * Initialize a new AST node struct.
 */
mrk_err mrk_ast_node_init(mrk_ast_node **out);

mrk_err mrk_ast_node_child_append(mrk_ast_node *parent, mrk_ast_node *child);

#endif
